%
% This file is part of the Omega project, which
% is based on the teTeX distribution,
% version 0.4, patch level 2.
% The file is
% Copyright (c) 1995,1996 John Plaice and Yannis Haralambous
% This file was last modified on 2 October 1996.
% 
%---------------------------------------
@x
if not b_open_in(ocp_file) then ocp_abort("opening file");
@y
if not ocp_open_in(ocp_file) then ocp_abort("opening file");
@z
%---------------------------------------
@x
@d ocpget==get(ocp_file)
@d ocpbyte==ocp_file^
@y
@d ocpget==ocp_temp:=getc(ocp_file)
@d ocpbyte==ocp_temp
@z
%---------------------------------------
@x
for k:=0 to ocpmem_ptr-1 do dump_wd(ocp_info[k]);
dump_int(ocp_ptr);
for k:=null_ocp to ocp_ptr do
  @<Dump the array info for internal ocp number |k|@>;
@y
@<Dump the array info for internal ocp number |k|@>;
@z
%---------------------------------------
@x
for k:=0 to ocpmem_ptr-1 do undump_wd(ocp_info[k]);
undump_size(ocp_base)(ocp_biggest)('ocp max')(ocp_ptr);
for k:=null_ocp to ocp_ptr do
  @<Undump the array info for internal ocp number |k|@>
@y
@<Undump the array info for internal ocp number |k|@>
@z
%---------------------------------------
@x
@ @<Dump the array info for internal ocp number |k|@>=
begin dump_int(ocp_name[k]);
dump_int(ocp_area[k]);
dump_int(ocp_input[k]);
dump_int(ocp_output[k]);
dump_int(ocp_no_states[k]);
dump_int(ocp_no_tables[k]);
print_nl("\ocp"); print_esc(ocp_id_text(k)); print_char("=");
print_file_name(ocp_name[k],ocp_area[k],"");
end
@y
@ @<Dump the array info for internal ocp number |k|@>=
begin dump_things(ocp_info[0], ocpmem_ptr);
dump_int(ocp_ptr);
dump_things(ocp_name[null_ocp], ocp_ptr+1-null_ocp);
dump_things(ocp_area[null_ocp], ocp_ptr+1-null_ocp);
dump_things(ocp_input[null_ocp], ocp_ptr+1-null_ocp);
dump_things(ocp_output[null_ocp], ocp_ptr+1-null_ocp);
dump_things(ocp_no_states[null_ocp], ocp_ptr+1-null_ocp);
dump_things(ocp_no_tables[null_ocp], ocp_ptr+1-null_ocp);
for k:=null_ocp to ocp_ptr do begin
  print_nl("\ocp"); print_esc(ocp_id_text(k)); print_char("=");
  print_file_name(ocp_name[k],ocp_area[k],"");
end;
end
@z
%---------------------------------------
@x
@ @<Undump the array info for internal ocp number |k|@>=
begin undump_int(ocp_name[k]);
undump_int(ocp_area[k]);
undump_int(ocp_input[k]);
undump_int(ocp_output[k]);
undump_int(ocp_no_states[k]);
undump_int(ocp_no_tables[k]);
end
@y
@  The way this is done in C makes the reference to
the internal font number meaningless, but putting the code
here preserves the association with the WEB modules.

@<Undump the array info for internal ocp number |k|@>=
begin undump_things(ocp_info[0], ocpmem_ptr);
undump_size(ocp_base)(ocp_biggest)('ocp max')(ocp_ptr);
undump_things(ocp_name[null_ocp], ocp_ptr+1-null_ocp);
undump_things(ocp_area[null_ocp], ocp_ptr+1-null_ocp);
undump_things(ocp_input[null_ocp], ocp_ptr+1-null_ocp);
undump_things(ocp_output[null_ocp], ocp_ptr+1-null_ocp);
undump_things(ocp_no_states[null_ocp], ocp_ptr+1-null_ocp);
undump_things(ocp_no_tables[null_ocp], ocp_ptr+1-null_ocp);
end
@z
%---------------------------------------
@x
@ @<Dump the ocp list information@>=
dump_int(ocp_listmem_ptr);
for k:=0 to ocp_listmem_ptr-1 do dump_wd(ocp_list_info[k]);
dump_int(ocp_list_ptr);
for k:=null_ocp_list to ocp_list_ptr do
begin
   dump_int(ocp_list_list[k]);
   print_nl("\ocplist"); 
   print_esc(ocp_list_id_text(k)); 
   print_char("=");
   print_ocp_list(ocp_list_list[k]);
end;
dump_int(ocp_lstackmem_ptr);
for k:=0 to ocp_lstackmem_ptr-1 do dump_wd(ocp_lstack_info[k])
@y
@ @<Dump the ocp list information@>=
dump_int(ocp_listmem_ptr);
dump_things(ocp_list_info[0], ocp_listmem_ptr);
dump_int(ocp_list_ptr);
dump_things(ocp_list_list[null_ocp_list], ocp_list_ptr+1-null_ocp_list);
for k:=null_ocp_list to ocp_list_ptr do
begin
   print_nl("\ocplist"); 
   print_esc(ocp_list_id_text(k)); 
   print_char("=");
   print_ocp_list(ocp_list_list[k]);
end;
dump_int(ocp_lstackmem_ptr);  
dump_things(ocp_lstack_info[0], ocp_lstackmem_ptr)
@z
%---------------------------------------
@x
@ @<Undump the ocp list information@>=
undump_size(1)(ocp_list_mem_size)('ocp list mem size')(ocp_listmem_ptr);
for k:=0 to ocp_listmem_ptr-1 do undump_wd(ocp_list_info[k]);
undump_size(ocp_list_base)(ocp_list_biggest)('ocp list max')(ocp_list_ptr);
for k:=null_ocp_list to ocp_list_ptr do
    undump_int(ocp_list_list[k]);
undump_size(1)(ocp_lstack_mem_size)('ocp lstack mem size')(ocp_lstackmem_ptr);
for k:=0 to ocp_lstackmem_ptr-1 do undump_wd(ocp_lstack_info[k])
@y
@ @<Undump the ocp list information@>=
undump_size(1)(ocp_list_mem_size)('ocp list mem size')(ocp_listmem_ptr);
undump_things(ocp_list_info[0], ocp_listmem_ptr);
undump_size(0)(1000000)('ocp list max')(ocp_list_ptr);
undump_things(ocp_list_list[null_ocp_list], ocp_list_ptr+1-null_ocp_list);
undump_size(0)(1000000)('ocp lstack mem size')(ocp_lstackmem_ptr);
undump_things(ocp_lstack_info[0], ocp_lstackmem_ptr)
@z
%---------------------------------------
